`include "Const.v"

module FPGA_TOP_ML505(
    input   GPIO_SW_C,
    input   USER_CLK,

    input   FPGA_SERIAL_RX,
    output  FPGA_SERIAL_TX
);
	//--------------------------------------------------------------------------
	//	Parameters
	//--------------------------------------------------------------------------
	parameter		ClockFreq =						100000000,			// See UART.v for details
					UARTBaud =						115200,				// See UART.v for details
					UARTDataBits =					8,					// See UART.v for details
					UARTParity =					0,					// See UART.v for details
					UARTStopBits =					1;					// See UART.v for details
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	//	Wires
	//--------------------------------------------------------------------------
	wire			Clock, Reset;
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	//	Clock & Reset
	//--------------------------------------------------------------------------
	BUFG			clockBuf(	.I(					USER_CLK),
								.O(					Clock));

	ButtonParse		#(			.Width(				1),
								.DebWidth(			`log2(ClockFreq / 100)),
								.EdgeOutWidth(		1)) 
					resetParse(	.Clock(				Clock),
								.Reset(				1'b0),
								.Enable(			1'b1),
								.In(				GPIO_SW_C),
								.Out(				Reset));
	//--------------------------------------------------------------------------
	
	//--------------------------------------------------------------------------
	//	UART 
	//--------------------------------------------------------------------------
	 UART			#(			.ClockFreq(			ClockFreq),
								.Baud(				UARTBaud),
								.Width(				UARTDataBits),
								.Parity(			UARTParity),
								.StopBits(			UARTStopBits))
					uart(		.Clock(				Clock),
								.Reset(				Reset),
								.DataIn(			/* You fill this in */),
								.DataInValid(		/* You fill this in */),
								.DataInReady(		/* You fill this in */),
								.DataOut(			/* You fill this in */),
								.DataOutValid(		/* You fill this in */),
								.DataOutReady(		/* You fill this in */),
								.SIn(				FPGA_SERIAL_RX),
								.SOut(				FPGA_SERIAL_TX));
	//--------------------------------------------------------------------------
	/*
		Implement your solution here.  
	*/
endmodule
//------------------------------------------------------------------------------
